---
title: Audio for Web games
slug: Games/Techniques/Audio_for_Web_Games
tags:
  - Audio
  - Games
  - Web Audio API
  - audio sprites
  - spatialization
  - syncing tracks
---
<div>{{GamesSidebar}}</div>

<p class="summary">Audio is an important part of any game; it adds feedback and atmosphere. Web-based audio is maturing fast, but there are still many browser differences to navigate. We often need to decide which audio parts are essential to our games' experience and which are nice to have but not essential, and devise a strategy accordingly. This article provides a detailed guide to implementing audio for web games, looking at what works currently across as wide a range of platforms as possible.</p>

<h2 id="Mobile_audio_caveats">Mobile audio caveats</h2>

<p>By far the most difficult platforms to provide web audio support for are mobile platforms. Unfortunately these are also the platforms that people often use to play games. There are a couple of differences between desktop and mobile browsers that may have caused browser vendors to make choices that can make web audio difficult for game developers to work with. Let's look at these now.</p>

<h3 id="Autoplay">Autoplay</h3>

<p>Browser autoplay policy now affects desktop <em>and</em> mobile browsers. There is further information about it <a href="https://developers.google.com/web/updates/2017/09/autoplay-policy-changes">here from the Google Developers site</a>.</p>

<p>It is worth noting that autoplay with sound is allowed if:</p>

<ul>
 <li>the User has interacted with the domain.</li>
 <li>on mobile the user has <a href="/en-US/docs/Web/Apps/Progressive/Add_to_home_screen">added the site to their home screen</a>.</li>
</ul>

<p>Many browsers will ignore any requests made by your game to automatically play audio; instead playback for audio needs to be started by a user-initiated event, such as a click or tap. This means you will have to structure your audio playback to take account of that. This is usually mitigated against by loading the audio in advance and priming it on a user-initiated event.</p>

<p>For more passive audio auto play, for example background music that starts as soon as a game loads, one trick is to detect <em>any</em> user initiated event and start playback then. For other more active sounds that are to be used during the game we could consider priming them as soon as something like a <em>Start</em> button is pressed.</p>

<p>To prime audio like this we want to play a part of it; for this reason it is useful to include a moment of silence at the end of your audio sample. Jumping to, playing, and then pausing that silence will mean we can now use JavaScript to play that file at arbitrary points. You can find out more about <a href="/en-US/docs/Web/API/Web_Audio_API/Best_practices#Autoplay_policy">best practises with the autoplay policy here</a>.</p>

<div class="note">
<p><strong>Note</strong>: Playing part of your file at zero volume could also work if the browser allows you to change volume (see below). Also note that playing and immediately pausing your audio does not guarantee that a small piece of audio won't be played.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Adding a web app to your mobile's homescreen may change its capabilities. In the case of autoplay on iOS, this appears to be the case currently. If possible, you should try your code on several devices and platforms to see how it works.</p>
</div>

<h3 id="Volume">Volume</h3>

<p>Programmatic volume control may be disabled in mobile browsers. The reason often given is that the user should be in control of the volume at the OS level and this shouldn't be overridden.</p>

<h3 id="Buffering_and_preloading">Buffering and preloading</h3>

<p>Likely as an attempt to mitigate runaway mobile network data use, we also often find that buffering is disabled before playback has been initiated. Buffering is the process of the browser downloading the media in advance, which we often need to do to ensure smooth playback.</p>

<p>The {{domxref("HTMLMediaElement")}} interface comes with <a href="/en-US/docs/Web/API/HTMLMediaElement#Properties">lots of properties</a> to help determine whether a track is in a state to be playable.</p>

<div class="note">
<p><strong>Note</strong>: In many ways the concept of buffering is an outdated one. As long as byte-range requests are accepted (which is the default behavior), we should be able to jump to a specific point in the audio without having to download the preceding content. However, preloading is still useful — without it, there would always need to be some client-server communication required before playing can commence.</p>
</div>

<h3 id="Concurrent_audio_playback">Concurrent audio playback</h3>

<p>A requirement of many games is the need to play more than one piece of audio at the same time; for example, there might be background music playing along with sound effects for various things happening in the game. Although the situation is soon going to get better with the adoption of the <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>, the current most widely-supported method — using the vanilla {{htmlelement("audio")}} element — leads to patchy results on mobile devices.

 <audio>element — results in patchy results on mobile devices.</audio>
</p>

<h3 id="Testing_and_support">Testing and support</h3>

<p>Here's a table that shows what mobile platforms support the features talked about above.</p>

<table class="standard-table">
 <caption>Mobile support for web audio features</caption>
 <thead>
  <tr>
   <th scope="row">Mobile browser</th>
   <th scope="col">Version</th>
   <th scope="col">Concurrent play</th>
   <th scope="col">Autoplay</th>
   <th scope="col">Volume adjusting</th>
   <th scope="col">Preload</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <th scope="row">Chrome (Android)</th>
   <td>69+</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
  </tr>
  <tr>
   <th scope="row">Firefox (Android)</th>
   <td>62+</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
  </tr>
  <tr>
   <th scope="row">Edge Mobile</th>
   <td></td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
  </tr>
  <tr>
   <th scope="row">Opera Mobile</th>
   <td>46+</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
  </tr>
  <tr>
   <th scope="row">Safari (iOS)</th>
   <td>7+</td>
   <td>Y/N*</td>
   <td>N</td>
   <td>N</td>
   <td>Y</td>
  </tr>
  <tr>
   <th scope="row">Android Browser</th>
   <td>67+</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
   <td>Y</td>
  </tr>
 </tbody>
</table>

<p>There's a <a href="/en-US/docs/Web/API/HTMLMediaElement#Browser_compatibility">full compatibility chart for mobile and desktop HTMLMediaElement support here</a>.</p>

<div class="note">
<p><strong>* Note</strong>: Safari 7 has issues playing if you try and start all pieces of audio simultaneously. If you stagger playback you may have some degree of success.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Concurrent audio playback is tested using our <a href="http://jsfiddle.net/dmkyaq0r/">concurrent audio test example</a>, where we attempt to play three pieces of audio at the same time using the standard audio API.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Simple autoplay functionality is tested with our <a href="http://jsfiddle.net/vpdspp2b/">autoplay test example</a>.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Volume changeability is tested with our <a href="http://jsfiddle.net/7ta12vw4/">volume test example</a>.</p>
</div>

<h2 id="Mobile_workarounds">Mobile workarounds</h2>

<p>Although mobile browsers can present problems, there are ways to work around the issues detailed above.</p>

<h3 id="Audio_sprites">Audio sprites</h3>

<p>Audio sprites borrow their name from <a href="/en-US/docs/Web/Guide/CSS/CSS_Image_Sprites">CSS sprites</a>, which is a visual technique for using CSS with a single graphic resource to break it into a series of sprites. We can apply the same principle to audio so that rather than having a bunch of small audio files that take time to load and play, we have one larger audio file containing all the smaller audio snippets we need. To play a specific sound from the file, we just use the known start and stop times for each audio sprite.</p>

<p>The advantage is that we can prime one piece of audio and have our sprites ready to go. To do this we can just play and instantly pause the larger piece of audio. You'll also reduce the number of server requests and save bandwidth.</p>

<pre class="brush: js notranslate">var myAudio = document.createElement("audio");
myAudio.src = "mysprite.mp3";
myAudio.play();
myAudio.pause();</pre>

<p>You'll need to sample the current time to know when to stop. If you space your individual sounds by at least 500ms then using the <code>timeUpdate</code> event (which fires every 250ms) should be sufficient. Your files may be slightly longer than they strictly need to be, but silence compresses well.</p>

<p>Here's an example of an audio sprite player — first let's set up the user interface in HTML:</p>

<pre class="brush: html notranslate">&lt;audio id="myAudio" src="http://jPlayer.org/tmp/countdown.mp3"&gt;&lt;/audio&gt;
&lt;button data-start="18" data-stop="19"&gt;0&lt;/button&gt;
&lt;button data-start="16" data-stop="17"&gt;1&lt;/button&gt;
&lt;button data-start="14" data-stop="15"&gt;2&lt;/button&gt;
&lt;button data-start="12" data-stop="13"&gt;3&lt;/button&gt;
&lt;button data-start="10" data-stop="11"&gt;4&lt;/button&gt;
&lt;button data-start="8"  data-stop="9"&gt;5&lt;/button&gt;
&lt;button data-start="6"  data-stop="7"&gt;6&lt;/button&gt;
&lt;button data-start="4"  data-stop="5"&gt;7&lt;/button&gt;
&lt;button data-start="2"  data-stop="3"&gt;8&lt;/button&gt;
&lt;button data-start="0"  data-stop="1"&gt;9&lt;/button&gt;</pre>

<p>Now we have buttons with start and stop times in seconds. The "countdown.mp3" MP3 file consists of a number being spoken every 2 seconds, the idea being that we play back that number when the corresponding button is pressed.</p>

<p>Let's add some JavaScript to make this work:</p>

<pre class="brush: js notranslate">var myAudio = document.getElementById('myAudio');
var buttons = document.getElementsByTagName('button');
var stopTime = 0;

for (var i = 0; i &lt; buttons.length; i++) {
  buttons[i].addEventListener('click', function() {
    myAudio.currentTime = this.getAttribute("data-start");
    stopTime = this.getAttribute("data-stop");
    myAudio.play();
  }, false);
}

myAudio.addEventListener('timeupdate', function() {
  if (this.currentTime &gt; stopTime) {
    this.pause();
  }
}, false);</pre>

<div class="note">
<p><strong>Note</strong>: You can <a href="http://jsfiddle.net/59vwaame/">try out our audio sprite player live</a> on JSFiddle.</p>
</div>

<div class="note">
<p><strong>Note</strong>: On mobile we may need to trigger this code from a user-initiated event such as a start button being pressed, as described above.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Watch out for bit rates. Encoding your audio at lower bit rates means smaller file sizes but lower seeking accuracy.</p>
</div>

<h3 id="Background_music">Background music</h3>

<p>Music in games can have a powerful emotional effect. You can mix and match various music samples and assuming you can control the volume of your audio element you could cross-fade different musical pieces. Using the <code><a href="/en-US/docs/Web/API/HTMLMediaElement/playbackRate">playbackRate()</a></code> method you can even adjust the speed of your music without affecting the pitch, to sync it up better with the action.</p>

<p>All this is possible using the standard {{htmlelement("audio")}} element and associated {{domxref("HTMLMediaElement API")}}, but it becomes much easier and more flexible with the more advanced <a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API</a>. Let's look at this next.

 <audio>element and associated HTMLMediaElement API, but it becomes much easier and more flexible with the more advanced Web Audio API. Let's look at this next.</audio>
</p>

<h3 id="Web_Audio_API_for_games">Web Audio API for games</h3>

<p>The Web Audio API is supported across all modern desktop and mobile browsers, with the exception of Opera Mini. With that in mind, it's an acceptable approach for many situations to use the Web Audio API (see the <a href="https://caniuse.com/#feat=audio-api">Can I use Web Audio API</a> page<a href="https://caniuse.com/#feat=audio-api"> </a>for more on browser compatibility). The Web Audio API is an advanced audio JavaScript API that is ideal for game audio. Developers can generate audio and manipulate audio samples as well as positioning sound in 3D game space.</p>

<p>A feasible cross-browser strategy would be to provide basic audio using the standard <code>&lt;audio&gt;</code> element and, where supported, enhance the experience using the Web Audio API.

 <audio>element and, where supported, enhance the experience using the Web Audio API.</audio>
</p>

<div class="note">
<p><strong>Note</strong>: Significantly, iOS Safari now supports the Web Audio API, which means it's now possible to write web-based games with native-quality audio for iOS.</p>
</div>

<p>As the Web Audio API allows precise timing and control of audio playback, we can use it to play samples at specific moments, which is a crucial immersive aspect of gaming. You want those explosions to be accompanied by a thundering boom, not followed by one, after all.</p>

<h3 id="Background_music_with_the_Web_Audio_API">Background music with the Web Audio API</h3>

<p>Although we can use the <code>&lt;audio&gt;</code> element to deliver linear background music that doesn't change in reaction to the game environment, the Web Audio API is ideal for implementing a more dynamic musical experience. You may want music to change depending on whether you are trying to build suspense or encourage the player in some way. Music is an important part of the gaming experience and depending on the type of game you are making you may wish to invest significant effort into getting it right.

 <audio>element to deliver linear background music that doesn't change in reaction to the game environment, the Web Audio API is ideal for implementing a more dynamic musical experience. You may want music to change depending on whether you are trying to build suspense or encourage the player in some way. Music is an important part of the gaming experience and depending on the type of game you are making you may wish to invest significant effort into getting it right.</audio>
</p>

<p>One way you can make your music soundtrack more dynamic is by splitting it up into component loops or tracks. This is often the way that musicians compose music anyway, and the Web Audio API is extremely good at keeping these parts in sync. Once you have the various tracks that make up your piece you can bring tracks in and out as appropriate.</p>

<p>You can also apply filters or effects to music. Is your character in a cave? Increase the echo. Maybe you have underwater scenes, during which you could apply a filter that muffles the sound.</p>

<p>Let's look at some Web Audio API techniques for dynamically adjusting music from its base tracks.</p>

<h3 id="Loading_your_tracks">Loading your tracks</h3>

<p>With the Web Audio API you can load separate tracks and loops individually using {{domxref("XMLHttpRequest")}} or the <a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a>, which means you can load them synchronously or in parallel. Loading synchronously might mean parts of your music are ready earlier and you can start playing them while others load.</p>

<p>Either way you may want to synchronize tracks or loops. The Web Audio API contains the notion of an internal clock that starts ticking the moment you create an audio context. You'll need to take account of the time between creating an audio context and when the first audio track starts playing. Recording this offset and querying the playing track's current time gives you enough information to synchronize separate pieces of audio.</p>

<p>To see this in action, let's lay out some separate tracks:</p>

<pre class="brush: html notranslate">&lt;section id="tracks"&gt;
  &lt;ul&gt;
    &lt;li data-loading="true"&gt;
      &lt;a href="leadguitar.mp3" class="track"&gt;Lead Guitar&lt;/a&gt;
      &lt;p class="loading-text"&gt;Loading...&lt;/p&gt;
      &lt;button data-playing="false" aria-decribedby="guitar-play-label"&gt;
        &lt;span id="guitar-play-label"&gt;Play&lt;/span&gt;
      &lt;/button&gt;
    &lt;/li&gt;
    &lt;li data-loading="true"&gt;
      &lt;a href="bassguitar.mp3" class="track"&gt;Bass Guitar&lt;/a&gt;
      &lt;p class="loading-text"&gt;Loading...&lt;/p&gt;
      &lt;button data-playing="false" aria-describedby="bass-play-label"&gt;
        &lt;span id="bass-play-label"&gt;Play&lt;/span&gt;
      &lt;/button&gt;
    &lt;/li&gt;
    &lt;li data-loading="true"&gt;
      &lt;a href="drums.mp3" class="track"&gt;Drums&lt;/a&gt;
      &lt;p class="loading-text"&gt;Loading...&lt;/p&gt;
      &lt;button data-playing="false" aria-describedby="drums-play-label"&gt;
        &lt;span id="drums-play-label"&gt;Play&lt;/span&gt;
      &lt;/button&gt;
    &lt;/li&gt;
    &lt;li data-loading="true"&gt;
      &lt;a href="horns.mp3" class="track"&gt;Horns&lt;/a&gt;
      &lt;p class="loading-text"&gt;Loading...&lt;/p&gt;
      &lt;button data-playing="false" aria-describedby="horns-play-label"&gt;
        &lt;span id="horns-play-label"&gt;Play&lt;/span&gt;
      &lt;/button&gt;
    &lt;/li&gt;
    &lt;li data-loading="true"&gt;
      &lt;a href="clav.mp3" class="track"&gt;Clavi&lt;/a&gt;
      &lt;p class="loading-text"&gt;Loading...&lt;/p&gt;
      &lt;button data-playing="false" aria-describedby="clavi-play-label"&gt;
        &lt;span id="clavi-play-label"&gt;Play&lt;/span&gt;
      &lt;/button&gt;
    &lt;/li&gt;
  &lt;/ul&gt;
  &lt;p class="sourced"&gt;All tracks sourced from &lt;a href="http://jplayer.org/"&gt;jplayer.org&lt;/a&gt;&lt;/p&gt;
&lt;/section&gt;
</pre>

<p>All of these tracks are the same tempo and are designed to be synchronized with each other, so we need to make sure they are loaded and available to the api <em>before</em> we are able to play them. We can do this with JavaScript's <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/async_function">async</a></code>/<code><a href="/en-US/docs/Web/JavaScript/Reference/Operators/await">await</a></code> functionality.</p>

<p>Once they are available to play, we need to make sure they start at the correct point that other tracks might be playing at, so they sync up.</p>

<p>Let's create our audio context:</p>

<pre class="brush: js notranslate">// for cross browser compatibility
const AudioContext = window.AudioContext || window.webkitAudioContext;
const audioCtx = new AudioContext();
</pre>

<p>Now let's select all the {{htmlelement("li")}} elements; later we can harness these elements to give us access to the track file path and each individual play button.</p>

<pre class="brush: js notranslate">const trackEls = document.querySelectorAll('li');
</pre>

<p>We want to make sure each file has loaded and been decoded into a buffer before we use it, so let's create an <code>async</code> function to allow us to do this:</p>

<pre class="brush: js notranslate">async function getFile(filepath) {
  const response = await fetch(filepath);
  const arrayBuffer = await response.arrayBuffer();
  const audioBuffer = await audioCtx.decodeAudioData(arrayBuffer);
  return audioBuffer;
}
</pre>

<p>We can then use the <code>await</code> operator when calling this function, which ensures that we can run subsequent code when it has finished executing.</p>

<p>Let's create another <code>async</code> function to set up the sample — we can combine the two async functions in a nice promise pattern to perform further actions when each file is loaded and buffered:</p>

<pre class="brush: js notranslate">async function loadFile(filePath) {
  const track = await getFile(filePath);
  return track;
}
</pre>

<p>Let's also create a <code>playTrack()</code> function, which we can call once a file has been fetched. We need an offset here, so if we have started one file playing, we have a record of how far through to start another file.</p>

<p><code>start()</code> takes two optional parameters. The first is when to commence playback and the second is where, which is our offset.</p>

<pre class="brush: js notranslate">let offset = 0;

function playTrack(audioBuffer) {
  const trackSource = audioCtx.createBufferSource();
  trackSource.buffer = audioBuffer;
  trackSource.connect(audioCtx.destination)

  if (offset == 0) {
    trackSource.start();
    offset = audioCtx.currentTime;
  } else {
    trackSource.start(0, audioCtx.currentTime - offset);
  }

  return trackSource;
}
</pre>

<p>Finally, let's loop over our <code>&lt;li&gt;</code> elements, grab the correct file for each one and then allow playback by hiding the "loading" text and displaying the play button:</p>

<pre class="brush: js notranslate">trackEls.forEach((el, i) =&gt; {

  // get children
  const anchor = el.querySelector('a');
  const loadText = el.querySelector('p');
  const playButton = el.querySelector('button');

  // load file
  loadFile(anchor.href).then((track) =&gt; {

    // set loading to false
    el.dataset.loading = 'false';

    // hide loading text
    loadText.style.display = 'none';

    // show button
    playButton.style.display = 'inline-block';

    // allow play on click
    playButton.addEventListener('click', function() {

      // check if context is in suspended state (autoplay policy)
      if (audioCtx.state === 'suspended') {
        audioCtx.resume();
      }

      playTrack(track);
      playButton.dataset.playing = true;
    })
  })

})
</pre>

<div class="note">
<p><strong>Note</strong>: You can <a href="https://mdn.github.io/webaudio-examples/multi-track/">see this demo in action here</a> and <a href="https://github.com/mdn/webaudio-examples/tree/master/multi-track">view the source code here</a>.</p>
</div>

<p>In the context of your game world you may have loops and samples that are played in different circumstances, and it can be useful to be able to synchronize with other tracks for a more seamless experience.</p>

<div class="note">
<p><strong>Note</strong>: This example does not wait for the beat to end before introducing the next piece; we could do this if we knew the BPM (Beats Per Minute) of the tracks.</p>
</div>

<p>You may find that the introduction of a new track sounds more natural if it comes in on the beat/bar/phrase or whatever units you want to chunk your background music into.</p>

<p>To do this before playing the track you want to sync, you should calculate how long it is until the start of the next beat/bar etc.</p>

<p>Here's a bit of code that given a tempo (the time in seconds of your beat/bar) will calculate how long to wait until you play the next part — you feed the resulting value to the <code>start()</code> function with the first parameter, which takes the absolute time of when that playback should commence. Note the second parameter (where to start playing from in the new track) is relative:</p>

<pre class="brush: js notranslate">if (offset == 0) {
  source.start();
  offset = context.currentTime;
} else {
  var relativeTime = context.currentTime - offset;
  var beats = relativeTime / tempo;
  var remainder = beats - Math.floor(beats);
  var delay = tempo - (remainder*tempo);
  source.start(context.currentTime+delay, relativeTime+delay);
}</pre>

<div class="note">
<p><strong>Note</strong>: You can <a href="http://jsfiddle.net/c87z11jj/2/">try our wait calculator code</a> here, on JSFiddle (I've synched to the bar in this case).</p>
</div>

<div class="note">
<p><strong>Note</strong>: If the first parameter is 0 or less than the context <code>currentTime</code>, playback will commence immediately.</p>
</div>

<h3 id="Positional_audio">Positional audio</h3>

<p>Positional audio can be an important technique in making audio a key part of an immersive gaming experience. The Web Audio API not only enables us to position a number of audio sources in three-dimensional space but it can also allow us to apply filters that make that audio appear more realistic.</p>

<p>The <a href="/en-US/docs/Web/API/PannerNode"><code>pannerNode</code></a> harnesses the positional capabilities of the Web Audio API so we can relate further information about the game world to the player. There's a <a href="/en-US/docs/Web/API/Web_Audio_API/Web_audio_spatialization_basics">tutorial here</a> to help understand the <code>pannerNode</code> in better detail.</p>

<p>We can relate:</p>

<ul>
 <li>The position of objects</li>
 <li>The direction and movement of objects</li>
 <li>The environment (cavernous, underwater, etc.)</li>
</ul>

<p>This is especially useful in a three-dimensional environment rendered using WebGL, where the Web Audio API makes it possible to tie audio to the objects and viewpoints.</p>

<h2 id="See_Also">See Also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API">Web Audio API on MDN</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/audio"><code>&lt;audio&gt;</code> on MDN</a></li>
 <li><a href="http://www.html5rocks.com/en/tutorials/webaudio/games/">Developing Game Audio with the Web Audio API (HTML5Rocks)</a></li>
 <li><a href="http://www.html5rocks.com/en/tutorials/webaudio/positional_audio/">Mixing Positional Audio and WebGL (HTML5Rocks)</a></li>
 <li><a href="https://hacks.mozilla.org/2013/10/songs-of-diridum-pushing-the-web-audio-api-to-its-limits/">Songs of Diridum: Pushing the Web Audio API to Its Limits</a></li>
 <li><a href="http://pupunzi.open-lab.com/2013/03/13/making-html5-audio-actually-work-on-mobile/">Making HTML5 Audio Actually Work on Mobile</a></li>
 <li><a href="http://remysharp.com/2010/12/23/audio-sprites/">Audio Sprites (and fixes for iOS)</a><br>
   </li>
</ul>
